/*
 *
 *    soniK digital audio editor
 *    Copyright (C) 2003-2004, 2006  Robert Walker <rob@tenfoot.org.uk>
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */
#ifndef SONIK_AUDIO_DRAG_OBJECT_H
#define SONIK_AUDIO_DRAG_OBJECT_H

#include <qdragobject.h>

#include "sonik_types.h"

namespace Sonik
{
  class AudioDragObject : public QDragObject
  {
    Q_OBJECT
  public:
    AudioDragObject(SampleSegment data,
                    QWidget *dragSource = 0, const char *name = 0);
    virtual ~AudioDragObject();

    const char* format (int i) const;
    QByteArray  encodedData(const char *fmt) const;

    const SampleSegment& data() { return mData; }

    static bool canDecode(const QMimeSource *e);
    static bool decode(const QMimeSource *e, QByteArray &dest);

  private:
    const SampleSegment mData;
  };
}

#endif // SONIK_AUDIO_DRAG_OBJECT_H
