/*
 *
 *    soniK digital audio editor
 *    Copyright (C) 2003-2004, 2006  Robert Walker <rob@tenfoot.org.uk>
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */
#ifndef SONIK_CONFIG_DIALOG_H
#define SONIK_CONFIG_DIALOG_H

#include "part.h"
#include "plugin.h"

#include <kdialogbase.h>

#include <qvaluelist.h>

class DisplayConfig;

namespace Sonik
{
  class ConfigDialogPage : public QWidget
  {
    Q_OBJECT
  public:
    ConfigDialogPage(QWidget* parent=0, const char* name=0);
    virtual ~ConfigDialogPage() = 0;

    virtual void apply() = 0;
  };

  class ConfigDialog : public KDialogBase
  {
    Q_OBJECT
  public:
    ConfigDialog(Part& p, QWidget* parent=0, const char* name=0);
    virtual ~ConfigDialog();

  protected slots:
    void slotOk();
    void slotApply();

  private:
    void apply();

    Part&   mPart;
    QValueList<ConfigDialogPage *> mPages;
  };
}

#endif // SONIK_CONFIG_DIALOG_H
