/*
 *
 *    soniK digital audio editor
 *    Copyright (C) 2003-2004, 2006  Robert Walker <rob@tenfoot.org.uk>
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */
#ifndef SONIK_MULTI_PLUGIN_H
#define SONIK_MULTI_PLUGIN_H

#include "plugin.h"

namespace Sonik
{
  class MultiPlugin : public Plugin
  {
    Q_OBJECT
  public:
    typedef QPtrList<Sonik::Plugin> PluginList;

    MultiPlugin(const QString& pluginName,
                QObject* parent=0, const char* name=0,
                const QStringList& args=QStringList());
    virtual ~MultiPlugin() = 0;

    PluginList plugins();
  protected:
    void addPlugin(Sonik::Plugin* plugin);

    PluginList mPlugins;
  };
}

#endif // SONIK_MULTI_PLUGIN_H
